# Copyright 2017 Google Inc.
#
# Licensed under the Apache License, Version 2.0 (the &quot;License&quot;);
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This class is auto generated by the swagger code generator program.
# https://github.com/swagger-api/swagger-codegen.git
# Do not edit the class manually.

defmodule GoogleApi.CloudIot.V1.Model.GatewayConfig do
  @moduledoc """
  Gateway-related configuration and state.

  ## Attributes

  - gatewayAuthMethod (String.t): Indicates how to authorize and/or authenticate devices to access the gateway. Defaults to: `null`.
    - Enum - one of [GATEWAY_AUTH_METHOD_UNSPECIFIED, ASSOCIATION_ONLY, DEVICE_AUTH_TOKEN_ONLY, ASSOCIATION_AND_DEVICE_AUTH_TOKEN]
  - gatewayType (String.t): Indicates whether the device is a gateway. Defaults to: `null`.
    - Enum - one of [GATEWAY_TYPE_UNSPECIFIED, GATEWAY, NON_GATEWAY]
  - lastAccessedGatewayId (String.t): [Output only] The ID of the gateway the device accessed most recently. Defaults to: `null`.
  - lastAccessedGatewayTime (DateTime.t): [Output only] The most recent time at which the device accessed the gateway specified in &#x60;last_accessed_gateway&#x60;. Defaults to: `null`.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :gatewayAuthMethod => any(),
          :gatewayType => any(),
          :lastAccessedGatewayId => any(),
          :lastAccessedGatewayTime => DateTime.t()
        }

  field(:gatewayAuthMethod)
  field(:gatewayType)
  field(:lastAccessedGatewayId)
  field(:lastAccessedGatewayTime, as: DateTime)
end

defimpl Poison.Decoder, for: GoogleApi.CloudIot.V1.Model.GatewayConfig do
  def decode(value, options) do
    GoogleApi.CloudIot.V1.Model.GatewayConfig.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.CloudIot.V1.Model.GatewayConfig do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
