# Copyright 2017 Google Inc.
#
# Licensed under the Apache License, Version 2.0 (the &quot;License&quot;);
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This class is auto generated by the swagger code generator program.
# https://github.com/swagger-api/swagger-codegen.git
# Do not edit the class manually.

defmodule GoogleApi.CloudIot.V1.Model.PublicKeyCertificate do
  @moduledoc """
  A public key certificate format and data.

  ## Attributes

  - certificate (String.t): The certificate data. Defaults to: `null`.
  - format (String.t): The certificate format. Defaults to: `null`.
    - Enum - one of [UNSPECIFIED_PUBLIC_KEY_CERTIFICATE_FORMAT, X509_CERTIFICATE_PEM]
  - x509Details (X509CertificateDetails): [Output only] The certificate details. Used only for X.509 certificates. Defaults to: `null`.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :certificate => any(),
          :format => any(),
          :x509Details => GoogleApi.CloudIot.V1.Model.X509CertificateDetails.t()
        }

  field(:certificate)
  field(:format)
  field(:x509Details, as: GoogleApi.CloudIot.V1.Model.X509CertificateDetails)
end

defimpl Poison.Decoder, for: GoogleApi.CloudIot.V1.Model.PublicKeyCertificate do
  def decode(value, options) do
    GoogleApi.CloudIot.V1.Model.PublicKeyCertificate.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.CloudIot.V1.Model.PublicKeyCertificate do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
